using System;
using DasConzoleCore;
using DasConzoleCore.Data;
using DasConzoleCore.UI;
using LyokoCMD.Sim.Virtual;
using LyokoCMD.Sim.Virtual.World;

namespace LyokoCMD.CommandLine.Apps {
    public class SectorMapApp : Application {
        
        public Sector Sector { get; }

        public SectorMapApp(Sector s) : this(s, new NonPersistentSettingsManager()) { }

        public SectorMapApp(Sector s, ISettingsManager settings) : base($"Carte de {s.Name}", new Version(0, 1), settings) {
            this.Sector = s;
        }

        public override void Run() {
            Console.Clear();
            foreach (Virtualizable virtualizable in Sector.Objects)
            {
                int x = (int) ((virtualizable.Coordinates.Item1 + 90) * Console.WindowWidth /
                               (Coordinates.MaxValue.Item1 + 90));
                int y = (int) ((virtualizable.Coordinates.Item2 + 180) * Console.WindowHeight /
                               (Coordinates.MaxValue.Item2 + 180));
                Text.WriteAt(x, y, virtualizable.Name.Substring(0, 1));
            }
            Console.ReadKey(true);
            Console.Clear();
        }
    }
}
