﻿using System;
using DasConzoleCore;
using DasConzoleCore.Commands;
using DasConzoleCore.UI;

namespace LyokoCMD.CommandLine.Commands
{
    class AboutCommand : Command
    {
        public override string[] Names => new string[] { "about" };

        public override string Description => "Afficher des informations sur l'application.";

        public override string HelpText => "Usage : about [short]\nAffiche des informations sur l'application.\nL'argument 'short' donne un affichage moins verbeux.";

        public override void Run(CommandApp app, string[] args)
        {
            if (args.Length > 0 && args[0].Trim().ToLower() == "short")
                Console.WriteLine(app.TitleLine);
            else
                Text.WriteWrapped($"Nom de l'application : {app.Name}\nVersion : {app.VersionLine}");
        }
    }
}
