﻿using System;
using DasConzoleCore;
using DasConzoleCore.Commands;
using DasConzoleCore.UI;
using LyokoCMD.Sim;

namespace LyokoCMD.CommandLine.Commands
{
    public class EnergyCommand : Command
    {
        public override string[] Names => new string[] { "energy" };

        public override string Description => "Afficher l'état énergétique du supercalculateur.";

        public override string HelpText => "Usage : energy\nAffiche un état détaillé de l'énergie du supercalculateur.";

        public override void Run(CommandApp app, string[] args)
        {
            Supercomputer sc = Game.Objects.Get<Supercomputer>();
            if (!sc.Running) throw new InvalidOperationException("Impossible de se connecter au supercalculateur.");
            Console.WriteLine("Énergie totale      {0} unités", sc.TotalEnergy.ToString().PadLeft(10));
            Console.WriteLine("Énergie utilisée    {0} unités", sc.UsedEnergy.ToString().PadLeft(10));
            Console.WriteLine("Énergie disponible  {0} unités", sc.AvailableEnergy.ToString().PadLeft(10));
            Console.WriteLine();
            Console.WriteLine(Text.BuildTable(sc.EnergyProviders.All()));
        }
    }
}
