﻿using System;
using System.Linq;
using DasConzoleCore;
using DasConzoleCore.UI;
using DasConzoleCore.Commands;
using LyokoCMD.Sim;

namespace LyokoCMD.CommandLine.Commands
{
    public class TaskCommand : Command
    {
        public override string[] Names => new string[] { "task" };
        public override string Description => "Afficher et exécuter des programmes.";
        public override string HelpText => "Usage: task [nom] <arguments>\nExécute une tâche.\nSans paramètres, affiche les tâches disponibles.";
        public override void Run(CommandApp app, string[] args)
        {
            Supercomputer sc = Game.Objects.Get<Supercomputer>();
            if (!sc.Running) throw new InvalidOperationException("Impossible de se connecter au supercalculateur.");
            if (args.Length < 1) Console.WriteLine(Text.BuildTable(sc.Tasks.All()));
            else sc.RunTask(args[0], args.Skip(1).ToArray());
        }
    }
}
