﻿using System;
using DasConzoleCore;
using DasConzoleCore.Commands;
using LyokoCMD.Sim;

namespace LyokoCMD.CommandLine.Commands
{
    public class TimeWarpCommand : Command
    {
        public override string[] Names => new string[] { "timewarp" };
        public override string Description => "Lance un retour vers le passé.";
        public override string HelpText => "Alias pour la tâche de retour vers le passé du supercalculateur.\nUsage: timewarp [hours] [delay_seconds]";
        public override void Run(CommandApp app, string[] args)
        {
            Supercomputer sc = Game.Objects.Get<Supercomputer>();
            if (!sc.Running) throw new InvalidOperationException("Impossible de se connecter au supercalculateur.");
            if (args.Length < 1) throw new ArgumentException(HelpText);
            if (args.Length < 2)
            {
                args[2] = "0";
            }
            sc.RunTask("TimeWarp", args);
        }
    }
}
