﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DasConzoleCore;
using DasConzoleCore.UI;
using DasConzoleCore.Commands;
using LyokoCMD.Sim;
using LyokoCMD.Sim.Virtual;

namespace LyokoCMD.CommandLine.Commands
{
    public class VirtualizationCommand : Command
    {
        public override string[] Names => new string[] { "virt" };
        public override string Description => "Virtualiser une entité vers Lyoko.";
        public override string HelpText => "Alias pour la tâche de virtualisation du supercalculateur.\nUsage: virt [entité] [destination]\nPour afficher les entités et destinations disponibles, tapez virt list.\nPour une virtualisation différée : virt [entité] [destination] [délai]";
        public override void Run(CommandApp app, string[] args)
        {
            Supercomputer sc = Game.Objects.Get<Supercomputer>();
            if (!sc.Running) throw new InvalidOperationException("Impossible de se connecter au supercalculateur.");
            if (args.Length < 1) throw new ArgumentException(HelpText);
            if (args[0] == "list")
            {
                Console.WriteLine(Text.BuildSimpleTable(Game.Objects.All<UserVirtualizable>()));
            }
            else if (args.Length < 2) throw new ArgumentException(HelpText);
            else sc.RunTask("Virt", args);
        }
    }
}
