using System;
using System.Collections.Generic;
using DasConzoleCore;
using DasConzoleCore.Commands;
using DasConzoleCore.Data;

namespace LyokoCMD.CommandLine {
    public class PersistenceCommandApp : CommandApp {

        public ISettingsPersistenceManager SettingsPersistence;

        public PersistenceCommandApp(string AppName, Version AppVersion) : this(AppName, AppVersion, new TextSettingsPersistenceManager("settings.txt")) { }
        public PersistenceCommandApp(string AppName, Version AppVersion, List<Command> AppCommands) : this(AppName, AppVersion, new TextSettingsPersistenceManager("settings.txt")) { }
        public PersistenceCommandApp(string AppName, Version AppVersion, ISettingsPersistenceManager AppPersistence) : base(AppName, AppVersion, AppPersistence.GetSettingsManager()) {
            this.SettingsPersistence = AppPersistence;
        }
        public PersistenceCommandApp(string AppName, Version AppVersion, ISettingsPersistenceManager AppPersistence, List<Command> AppCommands) : base(AppName, AppVersion, AppPersistence.GetSettingsManager()) {
            this.SettingsPersistence = AppPersistence;    
        }
    }
}
