﻿using DasConzoleCore.UI;

namespace LyokoCMD.Sim.EnergyProviders
{
    /// <summary>
    /// Décrit un fournisseur d'énergie du supercalculateur.
    /// </summary>
    public abstract class EnergyProvider : ITableLineOutput
    {
        /// <summary>
        /// Nom affiché par les systèmes de gestion d'énergie.
        /// </summary>
        public abstract string Name { get; }

        /// <summary>
        /// Énergie maximum pouvant être fournie.
        /// </summary>
        public abstract double AvailableEnergy { get; }

        public string[] GetColumnNames() => new string[] { "Nom", "Énergie" };

        public string[] GetLine() => new string[] { Name, AvailableEnergy.ToString() };
    }
}
