﻿namespace LyokoCMD.Sim.EnergyProviders
{
    /// <summary>
    /// Décrit une pile nucléaire du supercalculateur.
    /// </summary>
    class NuclearCell : EnergyProvider
    {
        protected double _Level = 1.0;

        /// <summary>
        /// Niveau de la pile nucléaire, entre 0.0 et 1.0. À 0.0, l'énergie n'est plus fournie.
        /// </summary>
        public double Level => _Level;

        public override string Name => "Pile nucléaire";

        public override double AvailableEnergy => _Level > 0.0 ? 1000.0 : 0.0;
    }
}
