﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace LyokoCMD.Sim.Extensions
{
    public static class IEnumerableExtensions
    {
        public static void ForEach<T>(this IEnumerable<T> ienum, Action<T> act)
        {
            foreach (T item in ienum) act(item);
        }

        public static IEnumerable<T> Sort<T>(this IEnumerable<T> ienum)
        {
            T[] array = ienum.ToArray();
            Array.Sort(array);
            return array;
        }

        public static IEnumerable<T> Sort<T>(this IEnumerable<T> ienum, Comparison<T> Comparer)
        {
            T[] array = ienum.ToArray();
            Array.Sort(array, Comparer);
            return array;
        }
    }
}
