﻿using DasConzoleCore.UI;

namespace LyokoCMD.Sim.Tasks
{
    /// <summary>
    /// Décrit une tâche exécutable au premier plan par le supercalculateur.
    /// </summary>
    public abstract class SCTask : ITableLineOutput
    {
        /// <summary>
        /// Nom de la tâche. Sera utilisé pour demander son exécution.
        /// Il est recommandé de n'utiliser que des caractères alphanumériques.
        /// </summary>
        public abstract string Name { get; }

        /// <summary>
        /// Énergie requise pour exécuter la tâche.
        /// </summary>
        public abstract double RequiredEnergy { get; }

        /// <summary>
        /// Exécuter une tâche.
        /// </summary>
        public abstract void Run(string[] args);

        public string[] GetColumnNames() => new string[] { "Nom", "Énergie" };
        public string[] GetLine() => new string[] { Name, RequiredEnergy.ToString() };
    }
}
