﻿using System;
using System.Collections.Generic;

namespace LyokoCMD.Sim.Virtual
{
    class Vehicle : Virtualizable
    {
        protected List<Human> _Riders;
        public List<Human> Riders => _Riders;

        public Vehicle(string name, Coordinates coords = null) : base(name, coords) => _Riders = new List<Human>();

        public void Mount(Human h)
        {
            if (!h.Virtualized) throw new ArgumentException("Cette personne n'a pas été virtualisée.");
            if (_Riders.Contains(h)) throw new ArgumentException("Cette personne est déjà sur le véhicule.");
            _Riders.Add(h);
        }

        public void Unmount(Human h)
        {
            if (!_Riders.Remove(h)) throw new ArgumentException("Cette personne n'est pas sur le véhicule.");
        }
    }
}
