﻿using System;
using System.Collections.Generic;

namespace LyokoCMD.Sim.Virtual.World
{
    /// <summary>
    /// Décrit un coeur de Lyoko.
    /// </summary>
    public class Heart
    {
        private int _life = 100;
        public int Life
        {
            get => _life;
            set
            {
                if (_life > 1 && _life - value < 1)
                {
                    _life = 1;
                }
                else
                {
                    _life -= value;
                }
            }
        }
        public DateTime LastHurt;
        public List<Sector> Sectors = new List<Sector>();

        public HeartStatus Status
        {
            get
            {
                if (Life <= 0)
                {
                    return HeartStatus.DEAD;
                }

                if (Life == 1)
                {
                    return HeartStatus.OPEN;
                }

                if (Life <= 15)
                {
                    return HeartStatus.FIRST_SHIELD;
                }

                if (Life <= 50)
                {
                    return HeartStatus.SECOND_SHIELD;
                }

                return HeartStatus.THIRD_SHIELD;
            }
        }

        private VirtualWorld _virtualWorld;

        public Heart(VirtualWorld virtualWorld)
        {
            _virtualWorld = virtualWorld;
        }
    }

    public enum HeartStatus
    {
        DEAD,
        OPEN,
        FIRST_SHIELD,
        SECOND_SHIELD,
        THIRD_SHIELD
    }
}
