﻿using System.Collections.Generic;
using DasConzoleCore.UI;
using LyokoCMD.Sim.Virtual.Towers;

namespace LyokoCMD.Sim.Virtual.World
{
    /// <summary>
    /// Décrit un territoire de Lyoko.
    /// </summary>
    public class Sector : VirtualizableVirtualizableContainer, ITableLineOutput
    {
        protected bool _Locked;
        public readonly string ShortName;
        public bool Locked => _Locked;

        public Sector(string Name, string shortName, bool locked = false) : base(Name, null, false)
        {
            this.ShortName = shortName;
            this._Locked = locked;
        }

        public string[] GetColumnNames() => new [] {"ID", "Name", "Locked"};

        public string[] GetLine() => new [] {this.ShortName, this.Name, this.Locked.ToString()};

        public void CreateTowers(int count)
        {
            for (int i = 1; i <= count; i++) Objects.Add(new Tower());
        }
    }
}
