﻿using System.Collections.Generic;
using System.Linq;

namespace LyokoCMD.Sim.Virtual.World
{
    /// <summary>
    /// Décrit le monde virtuel Lyoko.
    /// </summary>
    public class VirtualWorld : VirtualizableContainer
    {
        public List<Sector> Sectors => Objects.Cast<Sector>().ToList();
        public Heart Heart;
        public readonly string Name;

        public VirtualWorld(string name = "lyoko") : this(name, new List<Sector>())
        {
        }

        public VirtualWorld(string name, IEnumerable<Sector> sectors) : base()
        {
            this.Name = name;
            sectors.ToList().ForEach(this.Virtualize);
            Heart = new Heart(this);
        }
    }
}
