﻿namespace LyokoCMD.Sim.Workers
{
    /// <summary>
    /// Décrit un état de service de supercalculateur.
    /// </summary>
    public enum SCWorkerStatus
    {
        /// <summary>
        /// Service prêt à être exécuté manuellement.
        /// </summary>
        Ready,
        /// <summary>
        /// Service en cours d'exécution.
        /// </summary>
        Running,
        /// <summary>
        /// Service suspendu manuellement.
        /// </summary>
        Suspended,
        /// <summary>
        /// Service arrêté manuellement.
        /// </summary>
        Stopped,
        /// <summary>
        /// Service ayant terminé son exécution.
        /// </summary>
        Completed,
        /// <summary>
        /// Service ayant rencontré un problème.
        /// </summary>
        Failed,
        /// <summary>
        /// Service en attente d'un événement pour s'exécuter automatiquement.
        /// </summary>
        Waiting
    }
}
