using System;
using LyokoCMD.Sim.EnergyProviders;
using LyokoCMD.Sim.Virtual.World;

namespace LyokoCMD.Sim.Workers
{
    /// <summary>
    /// Décrit le monde virtuel Lyoko en arrière plan
    /// </summary>
    public class TimeWarpWorker : SCWorker
    {
        private long _LastTime;
        public long Delay
        {
            get => Delay;
            set
            {
                if (Delay <= 0)
                {
                    Delay = value * 3600;
                }
            }
        }

        public TimeWarpWorker() : base("TimeWarp") { }

        public override double RequiredEnergy => 0.0;

        protected override void PostStart()
        {
            _LastTime = DateTimeOffset.UtcNow.ToUnixTimeSeconds();
        }

        protected override void Run()
        {
            if (Delay <= 0)
            {
                Game.Objects.Get<TimeWarpEnergyProvider>().Warp();
                Game.Objects.Get<VirtualWorld>().MaterializeAll();
                Console.WriteLine("Retour vers le passé enclenché");
                Stop();
            }
            else
            {
                Delay -= DateTimeOffset.UtcNow.ToUnixTimeSeconds() - _LastTime;
            }
        }
    }
}
