using System;
using LyokoCMD.Sim.Virtual.World;

namespace LyokoCMD.Sim.Workers
{
    /// <summary>
    /// Décrit le monde virtuel Lyoko en arrière plan
    /// </summary>
    public class VirtualWorldWorker : SCWorker
    {
        public readonly VirtualWorld World;

        public VirtualWorldWorker(VirtualWorld world) : base(world.Name) => World = world;

        public override double RequiredEnergy => 300.0;

        protected override void PreSuspend()
        {
            throw new InvalidOperationException("Ce service ne peut pas être suspendu.");
        }

        protected override void PreStop()
        {
            World.MaterializeAll();
        }

        protected override void Run()
        {
        }
    }
}
